<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPieceEvent ArrayType
 * @subpackage Arrays
 */
class ArrayOfPieceEvent extends AbstractStructArrayBase
{
    /**
     * The ArrayOfPieceEventItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: 100
     * - minOccurs: 0
     * @var \StructType\PieceEvent[]
     */
    public $ArrayOfPieceEventItem;
    /**
     * Constructor method for ArrayOfPieceEvent
     * @uses ArrayOfPieceEvent::setArrayOfPieceEventItem()
     * @param \StructType\PieceEvent[] $arrayOfPieceEventItem
     */
    public function __construct(array $arrayOfPieceEventItem = array())
    {
        $this
            ->setArrayOfPieceEventItem($arrayOfPieceEventItem);
    }
    /**
     * Get ArrayOfPieceEventItem value
     * @return \StructType\PieceEvent[]|null
     */
    public function getArrayOfPieceEventItem()
    {
        return $this->ArrayOfPieceEventItem;
    }
    /**
     * This method is responsible for validating the values passed to the setArrayOfPieceEventItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setArrayOfPieceEventItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateArrayOfPieceEventItemForArrayConstraintsFromSetArrayOfPieceEventItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPieceEventArrayOfPieceEventItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfPieceEventArrayOfPieceEventItemItem instanceof \StructType\PieceEvent) {
                $invalidValues[] = is_object($arrayOfPieceEventArrayOfPieceEventItemItem) ? get_class($arrayOfPieceEventArrayOfPieceEventItemItem) : sprintf('%s(%s)', gettype($arrayOfPieceEventArrayOfPieceEventItemItem), var_export($arrayOfPieceEventArrayOfPieceEventItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ArrayOfPieceEventItem property can only contain items of type \StructType\PieceEvent, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ArrayOfPieceEventItem value
     * @throws \InvalidArgumentException
     * @param \StructType\PieceEvent[] $arrayOfPieceEventItem
     * @return \ArrayType\ArrayOfPieceEvent
     */
    public function setArrayOfPieceEventItem(array $arrayOfPieceEventItem = array())
    {
        // validation for constraint: array
        if ('' !== ($arrayOfPieceEventItemArrayErrorMessage = self::validateArrayOfPieceEventItemForArrayConstraintsFromSetArrayOfPieceEventItem($arrayOfPieceEventItem))) {
            throw new \InvalidArgumentException($arrayOfPieceEventItemArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(100)
        if (is_array($arrayOfPieceEventItem) && count($arrayOfPieceEventItem) > 100) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 100', count($arrayOfPieceEventItem)), __LINE__);
        }
        $this->ArrayOfPieceEventItem = $arrayOfPieceEventItem;
        return $this;
    }
    /**
     * Add item to ArrayOfPieceEventItem value
     * @throws \InvalidArgumentException
     * @param \StructType\PieceEvent $item
     * @return \ArrayType\ArrayOfPieceEvent
     */
    public function addToArrayOfPieceEventItem(\StructType\PieceEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PieceEvent) {
            throw new \InvalidArgumentException(sprintf('The ArrayOfPieceEventItem property can only contain items of type \StructType\PieceEvent, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(100)
        if (is_array($this->ArrayOfPieceEventItem) && count($this->ArrayOfPieceEventItem) >= 100) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 100', count($this->ArrayOfPieceEventItem)), __LINE__);
        }
        $this->ArrayOfPieceEventItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PieceEvent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PieceEvent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PieceEvent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PieceEvent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PieceEvent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayOfPieceEventItem
     */
    public function getAttributeName()
    {
        return 'ArrayOfPieceEventItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPieceEvent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
