<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPieceFault ArrayType
 * @subpackage Arrays
 */
class ArrayOfPieceFault extends AbstractStructArrayBase
{
    /**
     * The ArrayOfPieceFaultItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: 100
     * @var \StructType\PieceFault[]
     */
    public $ArrayOfPieceFaultItem;
    /**
     * Constructor method for ArrayOfPieceFault
     * @uses ArrayOfPieceFault::setArrayOfPieceFaultItem()
     * @param \StructType\PieceFault[] $arrayOfPieceFaultItem
     */
    public function __construct(array $arrayOfPieceFaultItem = array())
    {
        $this
            ->setArrayOfPieceFaultItem($arrayOfPieceFaultItem);
    }
    /**
     * Get ArrayOfPieceFaultItem value
     * @return \StructType\PieceFault[]|null
     */
    public function getArrayOfPieceFaultItem()
    {
        return $this->ArrayOfPieceFaultItem;
    }
    /**
     * This method is responsible for validating the values passed to the setArrayOfPieceFaultItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setArrayOfPieceFaultItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateArrayOfPieceFaultItemForArrayConstraintsFromSetArrayOfPieceFaultItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPieceFaultArrayOfPieceFaultItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfPieceFaultArrayOfPieceFaultItemItem instanceof \StructType\PieceFault) {
                $invalidValues[] = is_object($arrayOfPieceFaultArrayOfPieceFaultItemItem) ? get_class($arrayOfPieceFaultArrayOfPieceFaultItemItem) : sprintf('%s(%s)', gettype($arrayOfPieceFaultArrayOfPieceFaultItemItem), var_export($arrayOfPieceFaultArrayOfPieceFaultItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ArrayOfPieceFaultItem property can only contain items of type \StructType\PieceFault, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ArrayOfPieceFaultItem value
     * @throws \InvalidArgumentException
     * @param \StructType\PieceFault[] $arrayOfPieceFaultItem
     * @return \ArrayType\ArrayOfPieceFault
     */
    public function setArrayOfPieceFaultItem(array $arrayOfPieceFaultItem = array())
    {
        // validation for constraint: array
        if ('' !== ($arrayOfPieceFaultItemArrayErrorMessage = self::validateArrayOfPieceFaultItemForArrayConstraintsFromSetArrayOfPieceFaultItem($arrayOfPieceFaultItem))) {
            throw new \InvalidArgumentException($arrayOfPieceFaultItemArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(100)
        if (is_array($arrayOfPieceFaultItem) && count($arrayOfPieceFaultItem) > 100) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 100', count($arrayOfPieceFaultItem)), __LINE__);
        }
        $this->ArrayOfPieceFaultItem = $arrayOfPieceFaultItem;
        return $this;
    }
    /**
     * Add item to ArrayOfPieceFaultItem value
     * @throws \InvalidArgumentException
     * @param \StructType\PieceFault $item
     * @return \ArrayType\ArrayOfPieceFault
     */
    public function addToArrayOfPieceFaultItem(\StructType\PieceFault $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PieceFault) {
            throw new \InvalidArgumentException(sprintf('The ArrayOfPieceFaultItem property can only contain items of type \StructType\PieceFault, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(100)
        if (is_array($this->ArrayOfPieceFaultItem) && count($this->ArrayOfPieceFaultItem) >= 100) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 100', count($this->ArrayOfPieceFaultItem)), __LINE__);
        }
        $this->ArrayOfPieceFaultItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PieceFault|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PieceFault|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PieceFault|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PieceFault|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PieceFault|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayOfPieceFaultItem
     */
    public function getAttributeName()
    {
        return 'ArrayOfPieceFaultItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPieceFault
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
