<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPieceInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfPieceInfo extends AbstractStructArrayBase
{
    /**
     * The ArrayOfPieceInfoItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PieceInfo[]
     */
    public $ArrayOfPieceInfoItem;
    /**
     * Constructor method for ArrayOfPieceInfo
     * @uses ArrayOfPieceInfo::setArrayOfPieceInfoItem()
     * @param \StructType\PieceInfo[] $arrayOfPieceInfoItem
     */
    public function __construct(array $arrayOfPieceInfoItem = array())
    {
        $this
            ->setArrayOfPieceInfoItem($arrayOfPieceInfoItem);
    }
    /**
     * Get ArrayOfPieceInfoItem value
     * @return \StructType\PieceInfo[]|null
     */
    public function getArrayOfPieceInfoItem()
    {
        return $this->ArrayOfPieceInfoItem;
    }
    /**
     * This method is responsible for validating the values passed to the setArrayOfPieceInfoItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setArrayOfPieceInfoItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateArrayOfPieceInfoItemForArrayConstraintsFromSetArrayOfPieceInfoItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPieceInfoArrayOfPieceInfoItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfPieceInfoArrayOfPieceInfoItemItem instanceof \StructType\PieceInfo) {
                $invalidValues[] = is_object($arrayOfPieceInfoArrayOfPieceInfoItemItem) ? get_class($arrayOfPieceInfoArrayOfPieceInfoItemItem) : sprintf('%s(%s)', gettype($arrayOfPieceInfoArrayOfPieceInfoItemItem), var_export($arrayOfPieceInfoArrayOfPieceInfoItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ArrayOfPieceInfoItem property can only contain items of type \StructType\PieceInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ArrayOfPieceInfoItem value
     * @throws \InvalidArgumentException
     * @param \StructType\PieceInfo[] $arrayOfPieceInfoItem
     * @return \ArrayType\ArrayOfPieceInfo
     */
    public function setArrayOfPieceInfoItem(array $arrayOfPieceInfoItem = array())
    {
        // validation for constraint: array
        if ('' !== ($arrayOfPieceInfoItemArrayErrorMessage = self::validateArrayOfPieceInfoItemForArrayConstraintsFromSetArrayOfPieceInfoItem($arrayOfPieceInfoItem))) {
            throw new \InvalidArgumentException($arrayOfPieceInfoItemArrayErrorMessage, __LINE__);
        }
        $this->ArrayOfPieceInfoItem = $arrayOfPieceInfoItem;
        return $this;
    }
    /**
     * Add item to ArrayOfPieceInfoItem value
     * @throws \InvalidArgumentException
     * @param \StructType\PieceInfo $item
     * @return \ArrayType\ArrayOfPieceInfo
     */
    public function addToArrayOfPieceInfoItem(\StructType\PieceInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PieceInfo) {
            throw new \InvalidArgumentException(sprintf('The ArrayOfPieceInfoItem property can only contain items of type \StructType\PieceInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ArrayOfPieceInfoItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PieceInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PieceInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PieceInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PieceInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PieceInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayOfPieceInfoItem
     */
    public function getAttributeName()
    {
        return 'ArrayOfPieceInfoItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPieceInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
