<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'TrackingRequest' => '\\StructType\\TrackingRequest',
            'docTypeRef_ClientDetailType' => '\\StructType\\DocTypeRef_ClientDetailType',
            'Request' => '\\StructType\\Request',
            'ServiceHeader' => '\\StructType\\ServiceHeader',
            'ArrayOfAWBNumber' => '\\ArrayType\\ArrayOfAWBNumber',
            'ArrayOfTrackingPieceID' => '\\ArrayType\\ArrayOfTrackingPieceID',
            'ReferenceQuery' => '\\StructType\\ReferenceQuery',
            'Reference' => '\\StructType\\Reference',
            'ShipmentDate' => '\\StructType\\ShipmentDate',
            'TrackingResponse' => '\\StructType\\TrackingResponse',
            'Response' => '\\StructType\\Response',
            'ResponseServiceHeader' => '\\StructType\\ResponseServiceHeader',
            'ArrayOfAWBInfo' => '\\ArrayType\\ArrayOfAWBInfo',
            'AWBInfo' => '\\StructType\\AWBInfo',
            'TrackedBy' => '\\StructType\\TrackedBy',
            'Status' => '\\StructType\\Status',
            'ArrayOfCondition' => '\\ArrayType\\ArrayOfCondition',
            'Condition' => '\\StructType\\Condition',
            'ShipmentInfo' => '\\StructType\\ShipmentInfo',
            'OriginServiceArea' => '\\StructType\\OriginServiceArea',
            'DestinationServiceArea' => '\\StructType\\DestinationServiceArea',
            'Shipper' => '\\StructType\\Shipper',
            'Consignee' => '\\StructType\\Consignee',
            'ArrayOfShipmentEvent' => '\\ArrayType\\ArrayOfShipmentEvent',
            'ShipmentEvent' => '\\StructType\\ShipmentEvent',
            'ServiceEvent' => '\\StructType\\ServiceEvent',
            'EventRemarks' => '\\StructType\\EventRemarks',
            'ServiceArea' => '\\StructType\\ServiceArea',
            'ArrayOfChildShipmentIdentificationNumbers' => '\\ArrayType\\ArrayOfChildShipmentIdentificationNumbers',
            'TrackingPieces' => '\\StructType\\TrackingPieces',
            'PieceInfo' => '\\StructType\\PieceInfo',
            'PieceDetails' => '\\StructType\\PieceDetails',
            'PieceEvent' => '\\StructType\\PieceEvent',
            'ArrayOfPieceEvent' => '\\ArrayType\\ArrayOfPieceEvent',
            'ArrayOfPieceInfo' => '\\ArrayType\\ArrayOfPieceInfo',
            'Fault' => '\\StructType\\Fault',
            'PieceFault' => '\\StructType\\PieceFault',
            'ArrayOfPieceFault' => '\\ArrayType\\ArrayOfPieceFault',
            'trackShipmentRequest' => '\\StructType\\TrackShipmentRequest',
            'pubTrackingRequest' => '\\StructType\\PubTrackingRequest',
            'trackShipmentRequestResponse' => '\\StructType\\TrackShipmentRequestResponse',
            'pubTrackingResponse' => '\\StructType\\PubTrackingResponse',
            'ShipperReference' => '\\StructType\\ShipperReference',
        );
    }
}
