<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PieceInfo StructType
 * @subpackage Structs
 */
class PieceInfo extends AbstractStructBase
{
    /**
     * The PieceDetails
     * @var \StructType\PieceDetails
     */
    public $PieceDetails;
    /**
     * The PieceEvent
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPieceEvent
     */
    public $PieceEvent;
    /**
     * Constructor method for PieceInfo
     * @uses PieceInfo::setPieceDetails()
     * @uses PieceInfo::setPieceEvent()
     * @param \StructType\PieceDetails $pieceDetails
     * @param \ArrayType\ArrayOfPieceEvent $pieceEvent
     */
    public function __construct(\StructType\PieceDetails $pieceDetails = null, \ArrayType\ArrayOfPieceEvent $pieceEvent = null)
    {
        $this
            ->setPieceDetails($pieceDetails)
            ->setPieceEvent($pieceEvent);
    }
    /**
     * Get PieceDetails value
     * @return \StructType\PieceDetails|null
     */
    public function getPieceDetails()
    {
        return $this->PieceDetails;
    }
    /**
     * Set PieceDetails value
     * @param \StructType\PieceDetails $pieceDetails
     * @return \StructType\PieceInfo
     */
    public function setPieceDetails(\StructType\PieceDetails $pieceDetails = null)
    {
        $this->PieceDetails = $pieceDetails;
        return $this;
    }
    /**
     * Get PieceEvent value
     * @return \ArrayType\ArrayOfPieceEvent|null
     */
    public function getPieceEvent()
    {
        return $this->PieceEvent;
    }
    /**
     * Set PieceEvent value
     * @param \ArrayType\ArrayOfPieceEvent $pieceEvent
     * @return \StructType\PieceInfo
     */
    public function setPieceEvent(\ArrayType\ArrayOfPieceEvent $pieceEvent = null)
    {
        $this->PieceEvent = $pieceEvent;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PieceInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
