<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TrackingResponse StructType
 * Meta informations extracted from the WSDL
 * - type: s0:TrackingResponse
 * @subpackage Structs
 */
class TrackingResponse extends AbstractStructBase
{
    /**
     * The Response
     * @var \StructType\Response
     */
    public $Response;
    /**
     * The AWBInfo
     * @var \ArrayType\ArrayOfAWBInfo
     */
    public $AWBInfo;
    /**
     * The Fault
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Fault
     */
    public $Fault;
    /**
     * Constructor method for TrackingResponse
     * @uses TrackingResponse::setResponse()
     * @uses TrackingResponse::setAWBInfo()
     * @uses TrackingResponse::setFault()
     * @param \StructType\Response $response
     * @param \ArrayType\ArrayOfAWBInfo $aWBInfo
     * @param \StructType\Fault $fault
     */
    public function __construct(\StructType\Response $response = null, \ArrayType\ArrayOfAWBInfo $aWBInfo = null, \StructType\Fault $fault = null)
    {
        $this
            ->setResponse($response)
            ->setAWBInfo($aWBInfo)
            ->setFault($fault);
    }
    /**
     * Get Response value
     * @return \StructType\Response|null
     */
    public function getResponse()
    {
        return $this->Response;
    }
    /**
     * Set Response value
     * @param \StructType\Response $response
     * @return \StructType\TrackingResponse
     */
    public function setResponse(\StructType\Response $response = null)
    {
        $this->Response = $response;
        return $this;
    }
    /**
     * Get AWBInfo value
     * @return \ArrayType\ArrayOfAWBInfo|null
     */
    public function getAWBInfo()
    {
        return $this->AWBInfo;
    }
    /**
     * Set AWBInfo value
     * @param \ArrayType\ArrayOfAWBInfo $aWBInfo
     * @return \StructType\TrackingResponse
     */
    public function setAWBInfo(\ArrayType\ArrayOfAWBInfo $aWBInfo = null)
    {
        $this->AWBInfo = $aWBInfo;
        return $this;
    }
    /**
     * Get Fault value
     * @return \StructType\Fault|null
     */
    public function getFault()
    {
        return $this->Fault;
    }
    /**
     * Set Fault value
     * @param \StructType\Fault $fault
     * @return \StructType\TrackingResponse
     */
    public function setFault(\StructType\Fault $fault = null)
    {
        $this->Fault = $fault;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TrackingResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
